=== modified file 'NEWS'
--- NEWS	2008-06-26 06:06:49 +0000
+++ NEWS	2008-07-04 07:01:19 +0000
@@ -63,6 +63,9 @@
 
   TESTING:
 
+   * ``-Dmemory`` will cause /proc/PID/status to be catted before bzr
+     exits, allowing low-key analysis of peak memory use. (Robert Collins)
+
    * ``TestCaseWithTransport.make_branch_and_tree`` tries harder to return
      a tree with a ``branch`` attribute of the right format.  This was
      preventing some ``RemoteBranch`` tests from actually running with

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2008-05-28 23:20:33 +0000
+++ bzrlib/commands.py	2008-07-04 07:01:19 +0000
@@ -795,6 +795,17 @@
             ret = apply_coveraged(opt_coverage_dir, run, *run_argv)
         else:
             ret = run(*run_argv)
+        if 'memory' in debug.debug_flags:
+            try:
+                status_file = file('/proc/%s/status' % os.getpid(), 'rb')
+            except IOError:
+                pass
+            else:
+                status = status_file.read()
+                status_file.close()
+                trace.note("Process status after command:")
+                for line in status.splitlines():
+                    trace.note(line)
         return ret or 0
     finally:
         # reset, in case we may do other commands later within the same process

